//
//  RLayerGraphicsDevice.m
//  R
//
//  Created by Byron Ellis on 1/22/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "RLayerGraphicsDevice.h"


@implementation RLayerGraphicsDevice
- (void)makeLayer {
	if(NULL != layer) CGLayerRelease(layer);	
	layer = CGLayerCreateWithContext(CGDisplayGetDrawingContext([[[[NSScreen mainScreen] deviceDescription] objectForKey:@"NSScreenNumber"] unsignedIntegerValue]),
									 CGSizeMake(size.width,size.height),NULL);
	CGContextRef ctx = CGLayerGetContext(layer);
	//Put ourselves in to R coordinates
	CGContextTranslateCTM(ctx,0,size.height);
	CGContextScaleCTM(ctx,1.0,-1.0);
	[self setContext:ctx];
}	

+ (RLayerGraphicsDevice*)deviceWithSize:(NSSize)aSize deviceDesc:(void*)devDesc delegate:(id)delegate {
	return [[self alloc] initWithSize:aSize deviceDesc:devDesc delegate:delegate];
}

- (id)initWithSize:(NSSize)aSize deviceDesc:(void*)dd delegate:(id)del {
	if(nil == [super initWithContext:NULL deviceDesc:dd delegate:del]) return nil;
	size = aSize;
	layer= NULL;
	[self makeLayer];
	return self;
}

- (NSSize)deviceSize {
	NSSize newSize = [super deviceSize];
	if(newSize.width != size.width || newSize.height != size.height) {
		NSLog(@"Hmm a new size: %@",NSStringFromSize(newSize));		
		size = newSize;
		[self makeLayer];
	}
	return newSize;
}

- (void)newPage {
	[super newPage];
	[self makeLayer];
}

- (CGRect)bounds {
	return CGRectMake(0,0,size.width,size.height);
}

- (void)drawInRect:(NSRect)rect {
	CGContextDrawLayerInRect([[NSGraphicsContext currentContext] graphicsPort],CGRectMake(rect.origin.x,rect.origin.y,rect.size.width,rect.size.height),layer);
}

@end
